from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int, Directory, Boolean

Place_Seqs_Py_V0_1_0 = CommandToolBuilder(tool="place_seqs.py", base_command=["place_seqs.py"], inputs=[ToolInput(tag="in_study_fast_a", input_type=File(optional=True), prefix="--study_fasta", doc=InputDocumentation(doc="FASTA of unaligned study sequences.")), ToolInput(tag="in_sepp__tool", input_type=String(optional=True), prefix="-t", doc=InputDocumentation(doc="|sepp, --placement_tool epa-ng|sepp\nPlacement tool to use when placing sequences into\nreference tree. One of 'epa-ng' or 'sepp' must be\ninput (default: epa-ng)")), ToolInput(tag="in_ref_dir", input_type=File(optional=True), prefix="--ref_dir", doc=InputDocumentation(doc="Directory containing reference sequence files\n(default: /usr/local/lib/python3.6/site-\npackages/picrust2/default_files/prokaryotic/pro_ref).\nPlease see the online documentation for how to name\nthe files in this directory in order to use custom\nreference files.")), ToolInput(tag="in_out_tree", input_type=File(optional=True), prefix="--out_tree", doc=InputDocumentation(doc="Name of final output tree.")), ToolInput(tag="in_processes", input_type=Int(optional=True), prefix="--processes", doc=InputDocumentation(doc="Number of processes to run in parallel (default: 1).\nNote that this refers to multithreading rather than\nmultiprocessing when running EPA-ng and GAPPA.")), ToolInput(tag="in_intermediate", input_type=Directory(optional=True), prefix="--intermediate", doc=InputDocumentation(doc="Output folder for intermediate files (will be deleted\notherwise).")), ToolInput(tag="in_min_align", input_type=Int(optional=True), prefix="--min_align", doc=InputDocumentation(doc="Proportion of the total length of an input query\nsequence that must align with reference sequences. Any\nsequences with lengths below this value after making\nan alignment with reference sequences will be excluded\nfrom the placement and all subsequent steps. (default:\n0.80).")), ToolInput(tag="in_chunk_size", input_type=Int(optional=True), prefix="--chunk_size", doc=InputDocumentation(doc="Number of query seqs to read in at once for EPA-ng\n(default: 5000).")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="If specified, print out wrapped commands and other\ndetails to screen."))], outputs=[ToolOutput(tag="out_intermediate", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_intermediate", type_hint=File()), doc=OutputDocumentation(doc="Output folder for intermediate files (will be deleted\notherwise)."))], container="quay.io/biocontainers/picrust2:2.4.1--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Place_Seqs_Py_V0_1_0().translate("wdl")

